// ------------------------------------------------------------------------------------------
// Eywa's SCSS
//
// @author Eywa
// ------------------------------------------------------------------------------------------

// ------------------------------------------------------------------------------------------
// Media Queries & Breakpoints
// ------------------------------------------------------------------------------------------

// XS & Default: X-Small devices (portrait phones)
$ebp-xs-min: 0;
$ebp-xs: 0;
$ebp-xs-max: 575px;

// SM: Small devices (landscape phones)
$ebp-sm-min: 576px;
$ebp-sm: 576px;
$ebp-sm-max: 767px;

// MD: Medium devices (tablets)
$ebp-md-min: 768px;
$ebp-md: 768px;
$ebp-md-max: 991px;

// LG: Large devices (desktops)
$ebp-lg-min: 992px;
$ebp-lg: 992px;
$ebp-lg-max: 1199px;

// XL: X-Large devices (large desktops)
$ebp-xl-min: 1200px;
$ebp-xl: 1200px;
$ebp-xl-max: 1399px;

// XXL: XX-Large devices (extra large desktops)
$ebp-xxl-min: 1400px;
$ebp-xxl: 1400px;
$ebp-xxl-max: 1599px;

@mixin emq-min($var) {
  @media only screen and (min-width: $var) {
    @content;
  }
}

@mixin emq-max($var) {
  @media only screen and (max-width: $var) {
    @content;
  }
}

// ------------------------------------------------------------------------------------------
// Reset & Global
// ------------------------------------------------------------------------------------------

html {
  font-size: 14px;
  height: 100%;
  width: 100%;
}

body {
  box-sizing: border-box;
  font-size: 100%;
  height: 100%;
  margin: 0;
  padding: 0;
  display: flex;
  width: 100%;
}

* {
  box-sizing: border-box;
}

button,
input,
optgroup,
select,
textarea {
  background: none;
  border: none;
  font-family: inherit;
  font-size: 100%;
  margin: 0;
  padding: 0;
  text-decoration: none;
}

a {
  text-decoration: none;
}
button {
  cursor: pointer;
}

button,
input {
  overflow: visible;
}

button:focus,
input:focus {
  outline: none !important;
}

button,
[type='button'],
[type='reset'],
[type='submit'] {
  -webkit-appearance: button;
}

// ------------------------------------------------------------------------------------------
// Helpers: Display & Position
// ------------------------------------------------------------------------------------------

//
// Display & Position Mixin
//

@mixin make_display_positions($breakpoint-var: '') {
  @if $breakpoint-var == '' {
    .eh-d-block {
      display: block;
    }

    .eh-d-inline {
      display: inline;
    }

    .eh-d-iblock {
      display: inline-block;
    }

    .eh-d-flex {
      display: flex;
    }

    .eh-d-none {
      display: none;
    }

    .eh-v-visible {
      visibility: visible;
    }

    .eh-v-hidden {
      visibility: hidden;
    }

    .eh-pos-absolute {
      position: absolute;
    }

    .eh-pos-relative {
      position: relative;
    }

    .eh-pos-fixed {
      position: fixed;
    }
  } @else {
    .eh-#{$breakpoint-var}-d-block {
      display: block;
    }

    .eh-#{$breakpoint-var}-d-inline {
      display: inline;
    }

    .eh-#{$breakpoint-var}-d-iblock {
      display: inline-block;
    }

    .eh-#{$breakpoint-var}-d-flex {
      display: flex;
    }

    .eh-#{$breakpoint-var}-d-none {
      display: none;
    }

    .eh-#{$breakpoint-var}-v-visible {
      visibility: visible;
    }

    .eh-#{$breakpoint-var}-v-hidden {
      visibility: hidden;
    }

    .eh-#{$breakpoint-var}-pos-absolute {
      position: absolute;
    }

    .eh-#{$breakpoint-var}-pos-relative {
      position: relative;
    }

    .eh-#{$breakpoint-var}-pos-fixed {
      position: fixed;
    }
  }
}

//
// Classes
//

// XS & Default
@include make_display_positions();

// SM
@include emq-min($ebp-sm-min) {
  @include make_display_positions('sm');
}

// MD
@include emq-min($ebp-md-min) {
  @include make_display_positions('md');
}

// LG
@include emq-min($ebp-lg-min) {
  @include make_display_positions('lg');
}

// XXL
@include emq-min($ebp-xxl-min) {
  @include make_display_positions('xxl');
}

// ------------------------------------------------------------------------------------------
// Helpers: Sizing, Spacing
// ------------------------------------------------------------------------------------------

//
// Sizing Mixin
//

@mixin make_sizes($property, $breakpoint-var: '') {
  $property-prefix: #{str-slice($property, 0, 1)};

  @if $breakpoint-var == '' {
    @for $i from 0 to 301 {
      .eh-#{$property-prefix}-#{$i * 4} {
        #{$property}: #{$i * 4}px !important;
      }
    }

    @for $i from 1 to 21 {
      .eh-#{$property-prefix}-#{$i * 5}p {
        #{$property}: #{$i * 5}#{'%'} !important;
      }
    }

    .eh-#{$property-prefix}-100v {
      #{$property}: #{'100v'}#{$property-prefix} !important;
    }

    .eh-#{$property-prefix}-100v {
      #{$property}: #{'100v'}#{$property-prefix} !important;
    }

    @for $i from 0 to 301 {
      .eh-min#{$property-prefix}-#{$i * 4} {
        min-#{$property}: #{$i * 4}px !important;
      }
    }

    @for $i from 0 to 301 {
      .eh-max#{$property-prefix}-#{$i * 4} {
        max-#{$property}: #{$i * 4}px !important;
      }
    }

    @for $i from 1 to 21 {
      .eh-min#{$property-prefix}-#{$i * 5}p {
        min-#{$property}: #{$i * 5}#{'%'} !important;
      }
    }

    @for $i from 1 to 21 {
      .eh-max#{$property-prefix}-#{$i * 5}p {
        max-#{$property}: #{$i * 5}#{'%'} !important;
      }
    }

    .eh-min#{$property-prefix}-100v {
      min-#{$property}: #{'100v'}#{$property-prefix} !important;
    }

    @if $property-prefix == 'w' {
      .eh-#{$property-prefix}-fitcontent {
        width: fit-content !important;
      }
    }
  } @else {
    @for $i from 0 to 301 {
      .eh-#{$breakpoint-var}-#{$property-prefix}-#{$i * 4} {
        #{$property}: #{$i * 4}px !important;
      }
    }

    @for $i from 1 to 21 {
      .eh-#{$breakpoint-var}-#{$property-prefix}-#{$i * 5}p {
        #{$property}: #{$i * 5}#{'%'} !important;
      }
    }

    .eh-#{$breakpoint-var}-#{$property-prefix}-100v {
      #{$property}: #{'100v'}#{$property-prefix} !important;
    }

    @if $property-prefix == 'w' {
      .eh-#{$breakpoint-var}-#{$property-prefix}-fitcontent {
        width: fit-content !important;
      }
    }

    @for $i from 0 to 301 {
      .eh-#{$breakpoint-var}-min#{$property-prefix}-#{$i * 4} {
        min-#{$property}: #{$i * 4}px !important;
      }
    }

    @for $i from 0 to 301 {
      .eh-#{$breakpoint-var}-max#{$property-prefix}-#{$i * 4} {
        max-#{$property}: #{$i * 4}px !important;
      }
    }

    @for $i from 1 to 21 {
      .eh-#{$breakpoint-var}-min#{$property-prefix}-#{$i * 5}p {
        min-#{$property}: #{$i * 5}#{'%'} !important;
      }
    }

    @for $i from 1 to 21 {
      .eh-#{$breakpoint-var}-max#{$property-prefix}-#{$i * 5}p {
        max-#{$property}: #{$i * 5}#{'%'} !important;
      }
    }

    .eh-#{$breakpoint-var}-min#{$property-prefix}-100v {
      min-#{$property}: #{'100v'}#{$property-prefix} !important;
    }

    .eh-#{$breakpoint-var}-max#{$property-prefix}-100v {
      max-#{$property}: #{'100v'}#{$property-prefix} !important;
    }
  }
}

//
// Spacing Mixin
// @ToDo: Margins & padding based on 'em'

$sides: (all, x, y, top, bottom, left, right);

@mixin make_space($property, $breakpoint-var: '') {
  $property-prefix: #{str-slice($property, 0, 1)};

  @if $breakpoint-var == '' {
    @for $i from 0 to 21 {
      @each $side in $sides {
        @if $side == 'all' {
          .eh-#{$property-prefix}-#{$i * 2} {
            #{$property}: #{$i * 2}px !important;
          }
        } @else if $side == 'x' or $side == 'y' {
          .eh-#{$property-prefix}#{$side}-#{$i * 2} {
            @if $side == 'x' {
              #{$property}-left: #{$i * 2}px !important;
              #{$property}-right: #{$i * 2}px !important;
            } @else {
              #{$property}-top: #{$i * 2}px !important;
              #{$property}-bottom: #{$i * 2}px !important;
            }
          }
        } @else {
          .eh-#{$property-prefix}#{str-slice($side, 0, 1)}-#{$i * 2} {
            #{$property}-#{$side}: #{$i * 2}px !important;
          }
        }
      }
    }

    @if $property == 'margin' {
      .eh-mx-auto {
        margin-left: auto !important;
        margin-right: auto !important;
      }

      .eh-ml-auto {
        margin-left: auto !important;
      }

      .eh-mr-auto {
        margin-right: auto !important;
      }
    }

    .eh-xy-center {
      align-items: center;
      display: flex;
      justify-content: center;
    }
  } @else {
    @for $i from 0 to 21 {
      @each $side in $sides {
        @if $side == 'all' {
          .eh-#{$breakpoint-var}-#{$property-prefix}-#{$i * 2} {
            #{$property}: #{$i * 2}px !important;
          }
        } @else if $side == 'x' or $side == 'y' {
          .eh-#{$breakpoint-var}-#{$property-prefix}#{$side}-#{$i * 2} {
            @if $side == 'x' {
              #{$property}-left: #{$i * 2}px !important;
              #{$property}-right: #{$i * 2}px !important;
            } @else {
              #{$property}-top: #{$i * 2}px !important;
              #{$property}-bottom: #{$i * 2}px !important;
            }
          }
        } @else {
          .eh-#{$breakpoint-var}-#{$property-prefix}#{str-slice($side, 0, 1)}-#{$i
            *
            2} {
            #{$property}-#{$side}: #{$i * 2}px !important;
          }
        }
      }
    }

    @if $property == 'margin' {
      .eh-#{$breakpoint-var}-mx-auto {
        margin-left: auto !important;
        margin-right: auto !important;
      }

      .eh-#{$breakpoint-var}-ml-auto {
        margin-left: auto !important;
      }

      .eh-#{$breakpoint-var}-mr-auto {
        margin-right: auto !important;
      }
    }

    .eh-#{$breakpoint-var}-xy-center {
      align-items: center;
      display: flex;
      justify-content: center;
    }
  }
}

//
// Sizing & Spacing Classes
//

// XS & Default
@include make_sizes(width);
@include make_sizes(height);
@include make_space(margin);
@include make_space(padding);

.eh-fit {
  max-height: 100%;
  max-width: 100%;
}

.eh-l-spacer {
  &:first-child {
    margin-left: 0 !important;
  }
}

.eh-r-spacer {
  &:first-child {
    margin-right: 0 !important;
  }
}

.eh-x-spacer {
  &:first-child {
    margin-left: 0 !important;
    margin-right: 0 !important;
  }
}

.eh-t-spacer {
  &:first-child {
    margin-top: 0 !important;
  }
}

.eh-b-spacer {
  &:first-child {
    margin-bottom: 0 !important;
  }
}

.eh-y-spacer {
  &:first-child {
    margin-top: 0 !important;
    margin-bottom: 0 !important;
  }
}

.eh-for-spacer {
  margin-top: 1em;

  &:first-child {
    margin-top: 0;
  }
}

// SM
@include emq-min($ebp-sm-min) {
  @include make_sizes(width, 'sm');
  @include make_sizes(height, 'sm');
  @include make_space(margin, 'sm');
  @include make_space(padding, 'sm');
}

// MD
@include emq-min($ebp-md-min) {
  @include make_sizes(width, 'md');
  @include make_sizes(height, 'md');
  @include make_space(margin, 'md');
  @include make_space(padding, 'md');
}

// LG
@include emq-min($ebp-lg-min) {
  @include make_sizes(width, 'lg');
  @include make_sizes(height, 'lg');
  @include make_space(margin, 'lg');
  @include make_space(padding, 'lg');
}

// XL
@include emq-min($ebp-xl-min) {
  @include make_sizes(width, 'xl');
  @include make_sizes(height, 'xl');
  @include make_space(margin, 'xl');
  @include make_space(padding, 'xl');
}

// XXL
@include emq-min($ebp-xxl-min) {
  @include make_sizes(width, 'xxl');
  @include make_sizes(height, 'xxl');
  @include make_space(margin, 'xxl');
  @include make_space(padding, 'xxl');
}

// ------------------------------------------------------------------------------------------
// Helpers: Overflow
// ------------------------------------------------------------------------------------------

.eh-ofx-scroll {
  overflow-x: scroll;
}

.eh-ofy-scroll {
  overflow-y: scroll;
}

.eh-ofy-auto {
  overflow-y: auto;
}

.eh-ofy-hidden {
  overflow: hidden;
}

.eh-hide-scrollbars {
  -ms-overflow-style: none;
  scrollbar-width: none;
}

.eh-hide-scrollbars::-webkit-scrollbar {
  display: none;
}

// ------------------------------------------------------------------------------------------
// Helpers: Cursor
// ------------------------------------------------------------------------------------------

.eh-csr-ptr {
  cursor: pointer !important;
}

.eh-csr-dsb {
  cursor: not-allowed !important;
}

// ------------------------------------------------------------------------------------------
// Helpers: Text
// ------------------------------------------------------------------------------------------

//
// Text Alignments Mixin
//

@mixin make_text_alignments($breakpoint-var: '') {
  @if $breakpoint-var == '' {
    .eh-txt-center {
      text-align: center !important;
    }

    .eh-txt-left {
      text-align: left !important;
    }

    .eh-txt-right {
      text-align: right !important;
    }

    .eh-txt-justify {
      text-align: justify !important;
    }
  } @else {
    .eh-#{$breakpoint-var}-txt-center {
      text-align: center !important;
    }

    .eh-#{$breakpoint-var}-txt-left {
      text-align: left !important;
    }

    .eh-#{$breakpoint-var}-txt-right {
      text-align: right !important;
    }

    .eh-#{$breakpoint-var}-txt-justify {
      text-align: justify !important;
    }
  }
}

//
// Classes
//

// XS & Default
@include make_text_alignments();

// SM
@include emq-min($ebp-sm-min) {
  @include make_text_alignments('sm');
}

// MD
@include emq-min($ebp-md-min) {
  @include make_text_alignments('md');
}

// LG
@include emq-min($ebp-lg-min) {
  @include make_text_alignments('lg');
}

// XXL
@include emq-min($ebp-xxl-min) {
  @include make_text_alignments('xxl');
}

.eh-align-middle {
  vertical-align: middle;
}

.eh-txt-bold {
  font-weight: bold !important;
}

.eh-txt-500 {
  font-weight: 500 !important;
}

.eh-txt-normal {
  font-weight: normal !important;
}
.eh-txt-capital {
  text-transform: capitalize !important;
}

.eh-txt-uppercase {
  text-transform: uppercase !important;
}

.eh-txt-underline {
  text-decoration: underline !important;
}

.eh-txt-italic {
  font-style: italic;
}

.eh-txt-truncate {
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}

.eh-txt-breakword {
  word-break: break-word;
  -webkit-hyphens: auto;
  -ms-hyphens: auto;
  hyphens: auto;
}

.eh-txt-breakall {
  word-break: break-all;
  -webkit-hyphens: auto;
  -ms-hyphens: auto;
  hyphens: auto;
}

.eh-txt-prewrap {
  white-space: pre-wrap;
}

.eh-vertical-top {
  vertical-align: top;
}

.eh-vertical-middle {
  vertical-align: middle;
}

.eh-vertical-texttop {
  vertical-align: text-top;
}

// ----------

@mixin make_font_size() {
  @for $i from 5 to 26 {
    .eh-txt-#{$i * 2} {
      font-size: #{$i * 2}px !important;
    }
  }
}

@include make_font_size();

// ----------

$line_height: (1, 1.2, 1.6, 2, 3, 4, 5);

@mixin make-line_height() {
  @each $i in $line_height {
    @if $i == 1.2 {
      .eh-txt-lh1_2 {
        line-height: 1.2 !important;
      }
    } @else if $i == 1.6 {
      .eh-txt-lh1_6 {
        line-height: 1.6 !important;
      }
    } @else {
      .eh-txt-lh#{$i} {
        line-height: #{$i} !important;
      }
    }
  }
}

@include make-line_height();
